//+--------------------------------------------------------------------------------------------+
//|                                                                         ServicesMT.mqh     |
//|                                                                         Copyright  Zhunko |
//|16.10.2010 - 13.05.2014                                                  vadim@zhunko.ru    |
//+--------------------------------------------------------------------------------------------+
//|    "ServicesMT.dll".                                             |
//+--------------------------------------------------------------------------------------------+
//|  "ServicesMT.dll"  293            |
//| "MetaTrader 4".               |
//| . ,         .  |
//|       .                               |
//+--------------------------------------------------------------------------------------------+
//| Library "ServicesMT.dll" contains 290 service functions for terminal "MetaTrader 4".       |
//| Library could potentially work with any language localization terminal.                    |
//| But now implemented to work only with Russian and English localizations.                   |
//| New localizations will be added at the request of users.                                   |
//+--------------------------------------------------------------------------------------------+
//| ,      ,              |
//|  . : " ..." .                                  |
//|   :                                                                 |
//|   ServiceInitPathA(), ServiceInitPathW(), ServiceInitProcessId(),                          |
//|   ServiceGetAllSymbolsMA(), ServiceGetAllSymbolsMW(),                                      |
//|   ServiceOpenChartA(), ServiceOpenChartW(),                                                |
//|   ServiceOpenChartSetIndexTfA(), ServiceOpenChartSetIndexTfW(),                            |
//|   ServiceOpenChartSetPeriodA(), ServiceOpenChartSetPeriodW(),                              |
//|   ServiceOpenChartSetTfA(), ServiceOpenChartSetTfW(),                                      |
//|   ServiceTerminalBoxCloseByHandle(),                                                       |
//|   ServiceTerminalBoxCloseByNameA(), ServiceTerminalBoxCloseByNameW(),                      |
//|   ServiceTerminalSetTabByIndex(),                                                          |
//|   ServiceTerminalSetTabByNameA(), ServiceTerminalSetTabByNameW(),                          |
//|   ServiceMailboxDelete(),                                                                  |
//|   ServiceMailboxGetLineA(), ServiceMailboxGetLineW(),                                      |
//|   ServiceMailboxGetTime(), ServiceMailboxOpen(), ServiceMailboxRows(),                     |
//|   ServiceNewsColumns(), ServiceNewsGetCategoryA(), ServiceNewsGetCategoryW(),              |
//|   ServiceNewsGetStringTimeA(), ServiceNewsGetStringTimeW(),                                |
//|   ServiceNewsGetLineA(), ServiceNewsGetLineW(),                                            |
//|   ServiceNewsGetTime(), ServiceNewsGetThemeA(), ServiceNewsGetThemeW(),                    |
//|   ServiceNewsOpen(), ServiceNewsRows(),                                                    |
//|   ServiceDeleteIndicatorsByNameMA(), ServiceDeleteIndicatorsByNameMW(),                    |
//|   ServiceLoginApplyA(), ServiceLoginApplyW().                                              |
//+--------------------------------------------------------------------------------------------+

#ifndef BOOL
 #define BOOL   int
#endif

//
//====   4. ==============================================================================================================================================
#define LL_ENGLISH                    0x7D00 // 32000  .
#define LL_ARABIC                     0x7D01 // 32001  .
#define LL_BULGARIAN                  0x7D02 // 32002  .
#define LL_CHINESE_SIMPLE             0x7D03 // 32003  () .
#define LL_CHINESE_TRADITIONAL        0x7D04 // 32004  () .
#define LL_CROATIAN                   0x7D05 // 32005  .
#define LL_CZECH                      0x7D06 // 32006  .
#define LL_DANISH                     0x7D07 // 32007  .
#define LL_DUTCH                      0x7D08 // 32008  .
#define LL_ESTONIAN                   0x7D09 // 32009  .
#define LL_FARSI                      0x7D1A // 32010 .
#define LL_FRENCH                     0x7D1B // 32011  .
#define LL_GERMAN                     0x7D1C // 32012  .
#define LL_GREEK                      0x7D1D // 32013  .
#define LL_HEBREW                     0x7D1E // 32014 .
#define LL_HUNGARIAN                  0x7D1F // 32015  .
#define LL_INDONESIAN                 0x7D10 // 32016  .
#define LL_ITALIAN                    0x7D11 // 32017  .
#define LL_JAPANESE                   0x7D12 // 32018  .
#define LL_KOREAN                     0x7D13 // 32019  .
#define LL_LATVIAN                    0x7D14 // 32020  .
#define LL_LITHUANIAN                 0x7D15 // 32021  .
#define LL_MONGOLIAN                  0x7D16 // 32022  .
#define LL_POLISH                     0x7D17 // 32023  .
#define LL_PORTUGUESE                 0x7D18 // 32024  .
#define LL_RUSSIAN                    0x7D19 // 32025  .
#define LL_SERBIAN                    0x7D1A // 32026  .
#define LL_SLOVAK                     0x7D1B // 32027  .
#define LL_SPANISH                    0x7D1C // 32028  .
#define LL_SWEDISH                    0x7D1D // 32029  .
#define LL_TURKISH                    0x7D1E // 32030  .
#define LL_VIETNAMESE                 0x7D1F // 32031  .

//====     "ServiceLoadingQuotes()". =======================================================================================================
#define MLQ_STOP_TF                        0 //           .
#define MLQ_CONTINUED                      1 //      .
#define MLQ_FINISH                         2 //   .

//====      "ServiceSetViewChart()". ===================================================================================================
#define VS_BARS                            0 // .
#define VS_CANDLES                         1 //  .
#define VS_LINE                            2 // .

//====    . ===================================================================================================================================
#define PC_OK                         0x0001 //  "OK".
#define PC_CANCEL                     0x0002 //  "".
#define PC_RESET                      0x3021 //  "".
#define PC_TAB_CONTROL                0x3020 //  .

//----  "". ----------------------------------------------------------------------------------------------------------------------------------------------------
#define PC_COLOR_SCHEME               0x0503 //  .
#define PC_COLOR_BACKGROUND           0x041A // .
#define PC_COLOR_FOREGROUND           0x0421 // .
#define PC_COLOR_GRID                 0x0483 // .
#define PC_COLOR_BAR_UP               0x041C //  .
#define PC_COLOR_BAR_DOWN             0x041B //  .
#define PC_COLOR_BULL_CANDLE          0x041E //  .
#define PC_COLOR_BEAR_CANDLE          0x041D //  .
#define PC_COLOR_LINE_GRAPH           0x049B // .
#define PC_COLOR_LINE_VOLUMES         0x0569 // .
#define PC_COLOR_ASK_LINE             0x03F7 //  ASK.
#define PC_COLOR_STOP_LEVELS          0x0535 //  .

//----  "". ---------------------------------------------------------------------------------------------------------------------------------------------------
#define PC_COMMON_OFFLINE_CHART       0x04E9 //  .
#define PC_COMMON_FOREGROUND          0x04E4 //  .
#define PC_COMMON_SHIFT               0x04EF //  .
#define PC_COMMON_AUTOSCROLL          0x04ED //  .
#define PC_COMMON_BAR_CHART           0x04E1 //   - .
#define PC_COMMON_CANDLESTICKS        0x04E2 //   -  .
#define PC_COMMON_LINE_CHART          0x04E6 //   - .
#define PC_COMMON_OHLC                0x04EA //  OHLC.
#define PC_COMMON_ASK                 0x04E0 //   ASK.
#define PC_COMMON_PERIOD_SEPARATORS   0x04EE //   .
#define PC_COMMON_GRID                0x04E5 //  .
#define PC_COMMON_VOLUMES             0x04F0 //  .
#define PC_COMMON_OBJECT_DESCRIPTIONS 0x04E3 //   .
#define PC_COMMON_SCALE_FIX_1_TO_1    0x04EC //   1:1.
#define PC_COMMON_SCALE_FIX           0x04EB //  .
#define PC_COMMON_FIXED_MAX           0x04E7 // .
#define PC_COMMON_FIXED_MIN           0x04E8 // .

//----        . ------------------------------------------------------------------------------------------------
#define STATUS_UNKNOWN                     0 //   .
#define STATUS_SUCCESS                     1 //     .           .
#define STATUS_NO_CONNECT                  2 //  .
#define STATUS_INVALID_ACCOUNT             3 //  .
#define STATUS_COMMON_ERROR                4 //  .

//
#import "ServicesMT.dll"
 //
 // 1.   .
 //
 // 1.1.1.          .       .
 //             .     .
 //                    .  .    ANSI-.
 void ServiceInitPathA(uchar &szFullPath[]); //        4.
                                             //    ,     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 1.1.2.          .       .
 //             .     .
 //                    .  .    UNICODE-.
 void ServiceInitPathW(string sFullPath); //        4.
                                          //    ,     .
 //========================================================================================================================================================================
 // 1.2.       .       .
 //           .     .
 //                  .  .
 void ServiceInitProcessId(int dwProcessId); //  .      NULL.
 //
 // 2.       4.
 //
 // 2.1.    4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.1.1.1.   ANSI-  .
 string ServiceCurrentAccountNameA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.1.2.   UNICODE-  .
 string ServiceCurrentAccountNameW();
 //========================================================================================================================================================================
 // 2.1.2.     .
 int ServiceCurrentAccountNum();
 //========================================================================================================================================================================
 // 2.1.3.1.   ANSI-  .
 string ServiceCurrentServerA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.3.2.   UNICODE-  .
 string ServiceCurrentServerW();
 //========================================================================================================================================================================
 // 2.1.4.      4.
 int ServiceGetProcessId();
 //========================================================================================================================================================================
 // 2.1.5.       4.
 int ServiceHandleMT();
 //========================================================================================================================================================================
 // 2.1.6.1.   ANSI- .    "MetaTrader 4"  "MetaTrader 5".
 string ServiceNameMTA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.6.2.   UNICODE- .    "MetaTrader 4"  "MetaTrader 5".
 string ServiceNameMTW();
 //========================================================================================================================================================================
 // 2.1.7.1.    ANSI-  .
 string ServicePathMTA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.7.2.    UNICODE-  .
 string ServicePathMTW();
 //========================================================================================================================================================================
 // 2.1.8.1.    ANSI-          .
 string ServicePathDataMTA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.8.2.    UNICODE-          .
 string ServicePathDataMTW();
 //========================================================================================================================================================================
 // 2.1.9.1.    ANSI-    4     .
 string ServicePathDirectoryMTA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.9.2.    UNICODE-    4     .
 string ServicePathDirectoryMTW();
 //========================================================================================================================================================================
 // 2.1.10.1.    ANSI-     4     .
 string ServicePathServerA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.10.2.    UNICODE-     4     .
 string ServicePathServerW();
 //========================================================================================================================================================================
 // 2.1.11.         .
 //           STATUS_UNKNOWN             .
 //           STATUS_SUCCESS               .           .
 //           STATUS_NO_CONNECT         .
 //           STATUS_INVALID_ACCOUNT    .
 //           STATUS_COMMON_ERROR       .
 int ServiceStatusConnectId();
 //========================================================================================================================================================================
 // 2.1.12.1.   ANSI-      .
 string ServiceStatusConnectTextA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.12.2.   UNICODE-      .
 string ServiceStatusConnectTextW();
 //========================================================================================================================================================================
 // 2.1.13.1.   ANSI- c   4. : "4.0.0.445".
 string ServiceVersionA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.13.2.   UNICODE- c   4. : "4.0.0.445".
 string ServiceVersionW();
 //========================================================================================================================================================================
 // 2.1.14.      4.
 int ServiceVersionBuild();
 //========================================================================================================================================================================
 // 2.1.15.1.   ANSI-      4   "yyyy.mm.dd".
 string ServiceVersionDateA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.15.2.   UNICODE-      4   "yyyy.mm.dd".
 string ServiceVersionDateW();
 //========================================================================================================================================================================
 // 2.1.16.1.   ANSI-       4. : "Version: 4.00  Build 445 (09 Nov 2012)".
 string ServiceVersionFullA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.1.16.2.   UNICODE-       4. : "Version: 4.00  Build 445 (09 Nov 2012)".
 string ServiceVersionFullW();
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.2.     4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.2.1.     4.   TRUE,     ,  - FALSE.
 BOOL ServiceMetaTraderClose();
 //========================================================================================================================================================================
 // 2.2.2.     4.   TRUE,      ,  - FALSE.
 BOOL ServiceMetaTraderHide();
 //========================================================================================================================================================================
 // 2.2.3.      4.
 void ServiceMetaTraderHotKeys(int nKeyMode, //  -.      :
                                             // VK_SHIFT, VK_LSHIFT, VK_RSHIFT, VK_CONTROL, VK_LCONTROL, VK_RCONTROL, VK_MENU, VK_LMENU, VK_RMENU, VK_LWIN, VK_RWIN.
                               int nKey);    //   .
 //========================================================================================================================================================================
 // 2.2.4.       4.
 void ServiceMetaTraderKeyDown(int nKey); //  .
 //========================================================================================================================================================================
 // 2.2.5.     4.   TRUE,      ,  - FALSE.
 BOOL ServiceMetaTraderMaximize();
 //========================================================================================================================================================================
 // 2.2.6.     4.   TRUE,      ,  - FALSE.
 BOOL ServiceMetaTraderMinimize();
 //========================================================================================================================================================================
 // 2.2.7.    4.  ,   562 .
 void ServiceMetaTraderReboot();
 //========================================================================================================================================================================
 // 2.2.8.         4.   TRUE,      ,  - FALSE.
 BOOL ServiceMetaTraderRestore();
 //========================================================================================================================================================================
 // 2.2.9.     4.   TRUE,      ,  - FALSE.
 BOOL ServiceMetaTraderShow();
 //========================================================================================================================================================================
 // 2.2.10.      4.  ,      .
 void ServiceMetaTraderTitle(int bTitle); //      4. FALSE -   , TRUE -   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.3. , /    4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.3.1.    " "  4.
 void ServiceHideDataWindow();
 //========================================================================================================================================================================
 // 2.3.2.    " "  4.
 void ServiceHideMarketWatch();
 //========================================================================================================================================================================
 // 2.3.3.    ""  4.
 void ServiceHideNavigator();
 //========================================================================================================================================================================
 // 2.3.4.    ""  4.
 void ServiceHideTerminal();
 //========================================================================================================================================================================
 // 2.3.5.    ""  4.
 void ServiceHideTester();
 //========================================================================================================================================================================
 // 2.3.6.   TRUE,   " "  4 ,  - FALSE.
 BOOL ServiceIsVisibleDataWindow();
 //========================================================================================================================================================================
 // 2.3.7.   TRUE,   " "  4 ,  - FALSE.
 BOOL ServiceIsVisibleMarketWatch();
 //========================================================================================================================================================================
 // 2.3.8.   TRUE,   ""  4 ,  - FALSE.
 BOOL ServiceIsVisibleNavigator();
 //========================================================================================================================================================================
 // 2.3.9.   TRUE,   ""  4 ,  - FALSE.
 BOOL ServiceIsVisibleTerminal();
 //========================================================================================================================================================================
 // 2.3.10.   TRUE,   ""  4 ,  - FALSE.
 BOOL ServiceIsVisibleTester();
 //========================================================================================================================================================================
 // 2.3.11.    " "  4.
 void ServiceShowDataWindow();
 //========================================================================================================================================================================
 // 2.3.12.    " "  4.
 void ServiceShowMarketWatch();
 //========================================================================================================================================================================
 // 2.3.13.    ""  4.
 void ServiceShowNavigator();
 //========================================================================================================================================================================
 // 2.3.14.    ""  4.
 void ServiceShowTerminal();
 //========================================================================================================================================================================
 // 2.3.15.    ""  4.
 void ServiceShowTester();
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.4. ,     4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.4.1.    " ".          " ",  - NULL.
 int ServiceOpenGlobalVariables();
 //========================================================================================================================================================================
 // 2.4.2.    " ".          " ",  - NULL.
 int ServiceOpenHistoryCenter();
 //========================================================================================================================================================================
 // 2.4.3.      -     .
 int ServiceOpenLogin();
 //========================================================================================================================================================================
 // 2.4.4.    ""    .          "",
 //         - NULL.
 int ServiceOpenOptions(int nTab); //    "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.5.     4.
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 2.5.1.       4:
 //          LL_ENGLISH                .
 //          LL_ARABIC                 .
 //          LL_BULGARIAN              .
 //          LL_CHINESE_SIMPLE         () .
 //          LL_CHINESE_TRADITIONAL    () .
 //          LL_CROATIAN               .
 //          LL_CZECH                  .
 //          LL_DANISH                 .
 //          LL_DUTCH                  .
 //          LL_ESTONIAN               .
 //          LL_FARSI                 .
 //          LL_FRENCH                 .
 //          LL_GERMAN                 .
 //          LL_GREEK                  .
 //          LL_HEBREW                .
 //          LL_HUNGARIAN              .
 //          LL_INDONESIAN             .
 //          LL_ITALIAN                .
 //          LL_JAPANESE               .
 //          LL_KOREAN                 .
 //          LL_LATVIAN                .
 //          LL_LITHUANIAN             .
 //          LL_MONGOLIAN              .
 //          LL_POLISH                 .
 //          LL_PORTUGUESE             .
 //          LL_RUSSIAN                .
 //          LL_SERBIAN                .
 //          LL_SLOVAK                 .
 //          LL_SPANISH                .
 //          LL_SWEDISH                .
 //          LL_TURKISH                .
 //          LL_VIETNAMESE             .
 int ServiceGetLocalId();
 //========================================================================================================================================================================
 // 2.5.2.1.   ANSI-    4.
 //            "English"                .
 //            "Arabic"                 .
 //            "Bulgarian"              .
 //            "Chinese (Simple)"       () .
 //            "Chinese (Traditional)"  () .
 //            "Croatian"               .
 //            "Czech"                  .
 //            "Danish"                 .
 //            "Dutch"                  .
 //            "Estonian"               .
 //            "Farsi"                 .
 //            "French"                 .
 //            "German"                 .
 //            "Greek"                  .
 //            "Hebrew"                .
 //            "Hungarian"              .
 //            "Indonesian"             .
 //            "Italian"                .
 //            "Japanese"               .
 //            "Korean"                 .
 //            "Latvian"                .
 //            "Lithuanian"             .
 //            "Mongolian"              .
 //            "Polish"                 .
 //            "Portuguese (Brazil)"    .
 //            "Russian"                .
 //            "Serbian"                .
 //            "Slovak"                 .
 //            "Spanish"                .
 //            "Swedish"                .
 //            "Turkish"                .
 //            "Vietnamese"             .
 string ServiceGetLocalStrA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.5.2.2.   UNICODE-    4.
 //            "English"                .
 //            "Arabic"                 .
 //            "Bulgarian"              .
 //            "Chinese (Simple)"       () .
 //            "Chinese (Traditional)"  () .
 //            "Croatian"               .
 //            "Czech"                  .
 //            "Danish"                 .
 //            "Dutch"                  .
 //            "Estonian"               .
 //            "Farsi"                 .
 //            "French"                 .
 //            "German"                 .
 //            "Greek"                  .
 //            "Hebrew"                .
 //            "Hungarian"              .
 //            "Indonesian"             .
 //            "Italian"                .
 //            "Japanese"               .
 //            "Korean"                 .
 //            "Latvian"                .
 //            "Lithuanian"             .
 //            "Mongolian"              .
 //            "Polish"                 .
 //            "Portuguese (Brazil)"    .
 //            "Russian"                .
 //            "Serbian"                .
 //            "Slovak"                 .
 //            "Spanish"                .
 //            "Swedish"                .
 //            "Turkish"                .
 //            "Vietnamese"             .
 string ServiceGetLocalStrW();
 //========================================================================================================================================================================
 // 2.5.3.      4.
  void ServiceSetLocal(int  nCodeLocalization, //  .     :
                                               //   LL_ENGLISH                .
                                               //   LL_ARABIC                 .
                                               //   LL_BULGARIAN              .
                                               //   LL_CHINESE_SIMPLE         () .
                                               //   LL_CHINESE_TRADITIONAL    () .
                                               //   LL_CROATIAN               .
                                               //   LL_CZECH                  .
                                               //   LL_DANISH                 .
                                               //   LL_DUTCH                  .
                                               //   LL_ESTONIAN               .
                                               //   LL_FARSI                 .
                                               //   LL_FRENCH                 .
                                               //   LL_GERMAN                 .
                                               //   LL_GREEK                  .
                                               //   LL_HEBREW                .
                                               //   LL_HUNGARIAN              .
                                               //   LL_INDONESIAN             .
                                               //   LL_ITALIAN                .
                                               //   LL_JAPANESE               .
                                               //   LL_KOREAN                 .
                                               //   LL_LATVIAN                .
                                               //   LL_LITHUANIAN             .
                                               //   LL_POLISH                 .
                                               //   LL_PORTUGUESE             .
                                               //   LL_RUSSIAN                .
                                               //   LL_SERBIAN                .
                                               //   LL_SLOVAK                 .
                                               //   LL_SPANISH                .
                                               //   LL_SWEDISH                .
                                               //   LL_TURKISH                .
                                               //   LL_VIETNAMESE             .
                       BOOL bRestart);         //   ,   529 .   :
                                               //   TRUE  -     ;
                                               //   FALSE -      .
 //
 // 3.      .
 //
 // 3.1.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.1.1.  /   .
 void ServiceAutoScroll(int hwndChart); //    ,    .
 //========================================================================================================================================================================
 // 3.1.2.  /   .      TRUE,  - FALSE.
 BOOL ServiceShift(int hwndChart); //    ,   / .
 //========================================================================================================================================================================
 // 3.1.3.  /     .      TRUE,  - FALSE.
 BOOL ServiceShowGrid(int hwndChart); //    ,   /  .
 //========================================================================================================================================================================
 // 3.1.4.  /     .      TRUE,  - FALSE.
 BOOL ServiceShowVolume(int hwndChart); //    ,   /  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.2.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.2.1.       .      TRUE,  - FALSE.
 BOOL ServiceGetAutoScroll(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 3.2.2.    " "   .      TRUE,  - FALSE.
 BOOL ServiceGetScaleFix(int hwndChart); //    ,     " ".
 //========================================================================================================================================================================
 // 3.2.3.    "  1:1"   .      TRUE,  - FALSE.
 BOOL ServiceGetScaleFix1To1(int hwndChart); //    ,     "  1:1".
 //========================================================================================================================================================================
 // 3.2.4.    " "   .      TRUE,  - FALSE.
 BOOL ServiceGetForeground(int hwndChart); //    ,     " ".
 //========================================================================================================================================================================
 // 3.2.5.      .      TRUE,  - FALSE.
 BOOL ServiceGetOffline(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 3.2.6.      .      TRUE,  - FALSE.
 BOOL ServiceGetShift(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 3.2.7.      ASK   .      TRUE,  - FALSE.
 BOOL ServiceGetShowAsk(int hwndChart); //    ,       ASK.
 //========================================================================================================================================================================
 // 3.2.8.        .      TRUE,  - FALSE.
 BOOL ServiceGetShowGrid(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 3.2.9.         .      TRUE,  - FALSE.
 BOOL ServiceGetShowObjectDescript(int hwndChart); //    ,       .
 //========================================================================================================================================================================
 // 3.2.10.      OHLC   .      TRUE,  - FALSE.
 BOOL ServiceGetShowOHLC(int hwndChart); //    ,       OHLC.
 //========================================================================================================================================================================
 // 3.2.11.         .      TRUE,  - FALSE.
 BOOL ServiceGetShowPeriodSeparators(int hwndChart); //    ,       .
 //========================================================================================================================================================================
 // 3.2.12.        .      TRUE,  - FALSE.
 BOOL ServiceGetShowVolume(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 3.2.13.         .
 //             : VS_BARS     ;
 //                                           VS_CANDLES   ;
 //                                           VS_LINE     .
 int ServiceGetViewChart(int hwndChart); //    ,       .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.3.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.3.1.       .      .
 BOOL ServiceSetAutoScroll(int hwndChart,  //    ,     .
                           int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.2.      .      .
 BOOL ServiceSetOffline(int hwndChart,  //    ,     .
                        int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.3.      .
 void ServiceSetScale(int    hwndChart, //    ,     " ".
                      double dMaximum,  //  .
                      double dMinimum); //  .
 //========================================================================================================================================================================
 // 3.3.4.    " "   .      .
 BOOL ServiceSetScaleFix(int hwndChart,  //    ,     " ".
                         int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.5.    "  1:1"   .      .
 BOOL ServiceSetScaleFix1To1(int hwndChart,  //    ,     "  1:1".
                             int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.6.    " "   .      .
 BOOL ServiceSetForeground(int hwndChart,  //    ,     " ".
                           int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.7.      .      .
 BOOL ServiceSetShift(int hwndChart,  //    ,     .
                      int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.8.      ASK   .      .
 BOOL ServiceSetShowAsk(int hwndChart,  //    ,       ASK.
                        int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.9.        .      .
 BOOL ServiceSetShowGrid(int hwndChart,  //    ,      .
                         int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.10.         .      .
 BOOL ServiceSetShowObjectDescript(int hwndChart,  //    ,       .
                                   int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.11.      OHLC   .      .
 BOOL ServiceSetShowOHLC(int hwndChart,  //    ,       OHLC.
                         int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.12.         .      .
 BOOL ServiceSetShowPeriodSeparators(int hwndChart,  //    ,       .
                                     int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.13.        .      .
 BOOL ServiceSetShowVolume(int hwndChart,  //    ,      .
                           int bProperty); //  : FALSE -  , TRUE -  .
 //========================================================================================================================================================================
 // 3.3.14.        .      TRUE,  - FALSE.
 BOOL ServiceSetViewChart(int hwndChart, //    ,      .
                          int nView);    //     : VS_BARS     ;
                                         //                                   VS_CANDLES   ;
                                         //                                   VS_LINE     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.4.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 3.4.1.      .       .
 int ServiceOpenPropertiesChart(int hwndChart,    //   ,     .
                                int nTabControl); //   : 0 - "", 1 - "".
 //========================================================================================================================================================================
 // 3.4.2.            .
 void ServicePropertiesChartCheckBox(int  hwndChart,         //   ,     .
                                     int  bSet,              //     :
                                                             //   TRUE  -   ,   "dwControlId"  ,
                                                             //              "bProperty";
                                                             //   FALSE -    ,      .
                                     int &apbProperties[][], //        .  .
                                                             //  :
                                                             //   DWORD dwControlId;    .
                                                             //   BOOL  bProperty;      .
                                                             //   WORD  wDecimals;        .  .
                                                             //  MQL4-    3-  INT .  
                                                             //         2-  .
                                     int  nCount);           //    .    "apbProperties[]".
 //
 // 4.      .
 //
 // 4.1.       .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.1.1.   TRUE,       ,  - FALSE.
 BOOL ServiceChartCheckPressKey(int hwndChart, //    ,    .
                                int nKey);     //   .
 //========================================================================================================================================================================
 // 4.1.2.       .
 void ServiceChartHotKeys(int hwndChart, //   ,     .
                          int nKeyMode,  //  -.      :
                                         // VK_SHIFT, VK_LSHIFT, VK_RSHIFT, VK_CONTROL, VK_LCONTROL, VK_RCONTROL, VK_MENU, VK_LMENU, VK_RMENU, VK_LWIN, VK_RWIN.
                          int nKey);     //   .
 //========================================================================================================================================================================
 // 4.1.3.       .      TRUE,  - FALSE.
 BOOL ServiceChartKeyDown(int hwndChart, //   ,    .
                          int nKey);     //  .
 //========================================================================================================================================================================
 // 4.1.4.       .      TRUE,  - FALSE.
 BOOL ServiceChartKeyUp(int hwndChart, //   ,    .
                        int nKey);     //  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.2.      .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.2.1.     .
 void ServiceCloseAllCharts();
 //========================================================================================================================================================================
 // 4.2.2.     .      TRUE,  - FALSE.
 BOOL ServiceCloseChart(int hwndChart); //     .
 //========================================================================================================================================================================
 // 4.2.3.       .
 int ServiceGetHandleActiveChart();
 //========================================================================================================================================================================
 // 4.2.4.1.             .
 //            ,  ,        .    ANSI-.
 int ServiceGetHandleChartA(uchar &szSymbol[], //  .
                            int    nPeriod);   //    .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.2.4.2.             .
 //            ,  ,        .    UNICODE-.
 int ServiceGetHandleChartW(string sSymbol,  //  .
                            int    nPeriod); //    .
 //========================================================================================================================================================================
 // 4.2.5.                .
 int ServiceGetHandlesAllCharts(int &ahwndCharts[], //    .         .
                                int  nSize);        //   .
 //========================================================================================================================================================================
 // 4.2.6.1.                  
 //               .    ANSI-.
 int ServiceGetHandlesEqualChartsA(uchar &szSymbol[],    //  .
                                   int    nPeriod,       //    .
                                   int   &ahwndCharts[], //    .
                                   int    nSize);        //   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.2.6.2.                  
 //               .    UNICODE-.
 int ServiceGetHandlesEqualChartsW(string sSymbol,       //  .
                                   int    nPeriod,       //    .
                                   int   &ahwndCharts[], //    .
                                   int    nSize);        //   .
 //========================================================================================================================================================================
 // 4.2.7.               .
 int ServiceGetHandlesOfflineCharts(int &ahwndCharts[], //    .
                                    int  nSize);        //   .
 //========================================================================================================================================================================
 // 4.2.8.          online-    .
 int ServiceGetHandlesOnlineCharts(int &ahwndCharts[], //    .
                                   int  nSize);        //   .
 //========================================================================================================================================================================
 // 4.2.9.        .      TRUE,  - FALSE.
 BOOL ServiceIsChart(int hwndChart); //     .
 //========================================================================================================================================================================
 // 4.2.10.          .      TRUE,  - FALSE.
 BOOL ServiceIsChartActive(int hwndChart); //     .
 //========================================================================================================================================================================
 // 4.2.11.   TRUE,   ,  - FALSE.
 BOOL ServiceIsChartOffline(int hwndChart); //     .
 //========================================================================================================================================================================
 // 4.2.12.      .
 int ServiceNumberCharts();
 //========================================================================================================================================================================
 // 4.2.13.     .
 void ServiceSetActiveChart(int hwndChart); //     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.3.     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.3.1.      .      TRUE,  - FALSE.
 BOOL ServiceDeselectObjects(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 4.3.2.         .
 void ServiceSetBar(int      hwndChart, //    ,    .
                    datetime lTime);    //      .
 //========================================================================================================================================================================
 // 4.3.3.       .
 void ServiceStepByStep(int hwndChart); //    ,    .
 //========================================================================================================================================================================
 // 4.3.4.      .
 BOOL ServiceZoom(int hwndChart, //    ,     .
                  int bZoom);    //    : TRUE  -     ;
                                 //                                       FALSE -     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.4.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.4.1.         .
 void ServiceDeleteTemplate(int nTemplate); //     .      .    64.
 //========================================================================================================================================================================
 // 4.4.2.1.        .    ANSI-.
 void ServiceSaveTemplateA(int    hwndChart,         //    ,    .
                           uchar &szNameTemplate[]); //  ,    .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.4.2.2.        .    UNICODE-.
 void ServiceSaveTemplateW(int    hwndChart,      //    ,    .
                           string sNameTemplate); //  ,    .
 //========================================================================================================================================================================
 // 4.4.3.1.             .    ANSI-.
 void ServiceSetTemplateByNameA(int    hwndChart,        //    ,   .
                                uchar &szNameTemplate[], //     .
                                BOOL   bWaitEnd);        //     :
                                                         //   TRUE  -         ( );
                                                         //   FALSE -      ,     ( ).
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.4.3.2.             .    UNICODE-.
 void ServiceSetTemplateByNameW(int    hwndChart,     //    ,   .
                                string sNameTemplate, //     .
                                BOOL   bWaitEnd);     //     :
                                                      //   TRUE  -         ( );
                                                      //   FALSE -      ,     ( ).
 //========================================================================================================================================================================
 // 4.4.4.             .
 void ServiceSetTemplateByIndex(int  hwndChart, //    ,   .
                                int  nTemplate, //     .      .    64.
                                BOOL bWaitEnd); //     :
                                                //   TRUE  -         ( );
                                                //   FALSE -      ,     ( ).
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.5.       .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.5.1.1.          .    ANSI-.
 void ServiceSetTimeframeByNameA(int    hwndChart, //    ,    .
                                 uchar &szName[]); //   : "M1"    1 ;
                                                   //                          "M5"    5 ;
                                                   //                          "M15"  15 ;
                                                   //                          "M30"  30 ;
                                                   //                          "H1"    1 ;
                                                   //                          "H4"    4 ;
                                                   //                          "D1"    1 ;
                                                   //                          "W1"    1 ;
                                                   //                          "MN1"   1 .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.5.1.2.          .    UNICODE-.
 void ServiceSetTimeframeByNameW(int    hwndChart, //    ,    .
                                 string sName);    //   : "M1"    1 ;
                                                   //                          "M5"    5 ;
                                                   //                          "M15"  15 ;
                                                   //                          "M30"  30 ;
                                                   //                          "H1"    1 ;
                                                   //                          "H4"    4 ;
                                                   //                          "D1"    1 ;
                                                   //                          "W1"    1 ;
                                                   //                          "MN1"   1 .
 //========================================================================================================================================================================
 // 4.5.2.          .
 void ServiceSetTimeframeByIndex(int hwndChart,   //    ,    .
                                 int nTimeFrame); //     0  8.
 //========================================================================================================================================================================
 // 4.5.3.          .
 void ServiceSetTimeframeByPeriod(int hwndChart, //    ,    .
                                  int nPeriod);  //   : PERIOD_M1       1  1 ;
                                                 //                             PERIOD_M5       5  5 ;
                                                 //                             PERIOD_M15     15  15 ;
                                                 //                             PERIOD_M30     30  30 ;
                                                 //                             PERIOD_H1      60  1 ;
                                                 //                             PERIOD_H4     240  4 ;
                                                 //                             PERIOD_D1    1440  1 ;
                                                 //                             PERIOD_W1   10080  1 ;
                                                 //                             PERIOD_MN1  43200  1 .
 //========================================================================================================================================================================
 // 4.5.4.1.    /      .    ANSI-.
 void ServiceSetToolChartNamePeriodA(int    hwndChart,       //    ,    .
                                     uchar &szSymbol[],      //     " ".    ,   .
                                     uchar &szNamePeriod[]); //   .    ,   .
                                                             //  : "M1"    1 ;
                                                             //                     "M5"    5 ;
                                                             //                     "M15"  15 ;
                                                             //                     "M30"  30 ;
                                                             //                     "H1"    1 ;
                                                             //                     "H4"    4 ;
                                                             //                     "D1"    1 ;
                                                             //                     "W1"    1 ;
                                                             //                     "MN1"   1 .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.5.4.2.    /      .    UNICODE-.
 void ServiceSetToolChartNamePeriodW(int    hwndChart,    //    ,    .
                                     string sSymbol,      //     " ".    ,   .
                                     string sNamePeriod); //   .    ,   .
                                                          //  : "M1"    1 ;
                                                          //                     "M5"    5 ;
                                                          //                     "M15"  15 ;
                                                          //                     "M30"  30 ;
                                                          //                     "H1"    1 ;
                                                          //                     "H4"    4 ;
                                                          //                     "D1"    1 ;
                                                          //                     "W1"    1 ;
                                                          //                     "MN1"   1 .
 //========================================================================================================================================================================
 // 4.5.5.1.    /      .    ANSI-.
 void ServiceSetToolChartIndexPeriodA(int    hwndChart,   //    ,    .
                                      uchar &szSymbol[],  //     " ".    ,   .
                                      int    nTimeFrame); //     0  8.    ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.5.5.2.    /      .    UNICODE-.
 void ServiceSetToolChartIndexPeriodW(int    hwndChart,   //    ,    .
                                      string sSymbol,     //     " ".    ,   .
                                      int    nTimeFrame); //     0  8.    ,   .
 //========================================================================================================================================================================
 // 4.5.6.    /      .    ANSI-.
 void ServiceSetToolChartPeriodA(int    hwndChart,  //    ,    .
                                 uchar &szSymbol[], //     " ".    ,   .
                                 int    nPeriod);   //   .    ,   .
                                                    //  : PERIOD_M1       1   1 ;
                                                    //                     PERIOD_M5       5   5 ;
                                                    //                     PERIOD_M15     15  15 ;
                                                    //                     PERIOD_M30     30  30 ;
                                                    //                     PERIOD_H1      60   1 ;
                                                    //                     PERIOD_H4     240   4 ;
                                                    //                     PERIOD_D1    1440   1 ;
                                                    //                     PERIOD_W1   10080   1 ;
                                                    //                     PERIOD_MN1  43200   1 .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.5.6.    /      .    UNICODE-.
 void ServiceSetToolChartPeriodW(int    hwndChart, //    ,    .
                                 string sSymbol,   //     " ".    ,   .
                                 int    nPeriod);  //   .    ,   .
                                                   //  : PERIOD_M1       1   1 ;
                                                   //                     PERIOD_M5       5   5 ;
                                                   //                     PERIOD_M15     15  15 ;
                                                   //                     PERIOD_M30     30  30 ;
                                                   //                     PERIOD_H1      60   1 ;
                                                   //                     PERIOD_H4     240   4 ;
                                                   //                     PERIOD_D1    1440   1 ;
                                                   //                     PERIOD_W1   10080   1 ;
                                                   //                     PERIOD_MN1  43200   1 .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.6.       .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.6.1.           .
 void ServiceCmdClose(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 4.6.2.        .
 void ServiceCmdClear(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 4.6.3.       ,    ,      ,     .
 //              .
 int ServiceCmdCreat(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 4.6.4.         .    ,   TRUE,  - FALSE.
 BOOL ServiceCmdHas(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 4.6.5.         .    ,   TRUE.
 //                 FALSE.
 BOOL ServiceCmdIsVisible(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 4.6.6.         .       .
 int ServiceCmdOpen(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 4.6.7.1.        .    ANSI-.
 string ServiceCmdReadA(int hwndChart); //    ,       .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.6.7.2.        .    UNICODE-.
 string ServiceCmdReadW(int hwndChart); //    ,       .
 //========================================================================================================================================================================
 // 4.6.8.1.         .    ANSI-.
 void ServiceCmdWriteA(int    hwndChart, //    ,     .
                       uchar &szText[]); //     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.6.8.2.         .    UNICODE-.
 void ServiceCmdWriteW(int    hwndChart, //    ,     .
                       string sText);    //     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.7.     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.7.1.        .    ,      .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshAllCharts(int nPeriodMilliSec); //     .
 //========================================================================================================================================================================
 // 4.7.2.      .          .
 void ServiceRefreshAllOnceCharts();
 //========================================================================================================================================================================
 // 4.7.3.        .    ,       .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshChart(int hwndChart,        //    .
                          int nPeriodMilliSec); //     .
 //========================================================================================================================================================================
 // 4.7.4.        .    ,      .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshOfflineCharts(int nPeriodMilliSec); //     .
 //========================================================================================================================================================================
 // 4.7.5.    online-   .    ,      .
 //           "ServiceStopRefreshChart()"  "ServiceStopRefreshAllCharts()"   .
 void ServiceRefreshOnlineCharts(int nPeriodMilliSec); //     .
 //========================================================================================================================================================================
 // 4.7.6.     .
 void ServiceStopRefreshChart(int hwndChart); //   ,    .
 //========================================================================================================================================================================
 // 4.7.7.        bTerminate = FALSE,     .
 void ServiceStopRefreshAllCharts(int bTerminate); //      .
                                                   // FALSE -   , TRUE -   .
 //========================================================================================================================================================================
 // 4.7.8.        .
 void ServiceTickExpert(int hwndChart); //    ,     .
 //========================================================================================================================================================================
 // 4.7.9.        .
 void ServiceTickIndicators(int hwndChart); //    ,     .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.8.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 4.8.1.         .
 void ServiceDeleteProfile(int nProfile); //     .      .    64.
 //========================================================================================================================================================================
 // 4.8.2.1.   ANSI-  .
 string ServiceGetCurrentProfileA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.8.2.2.   UNICODE-  .
 string ServiceGetCurrentProfileW();
 //========================================================================================================================================================================
 // 4.8.3.     " ".
 //                 " ",  - NULL.
 int ServiceOpenSaveProfile();
 //========================================================================================================================================================================
 // 4.8.4.1.      .    ANSI-.
 void ServiceSaveProfileA(uchar &szNameProfile[]); //  ,    .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.8.4.2.      .    UNICODE-.
 void ServiceSaveProfileW(string sNameProfile); //  ,    .
 //========================================================================================================================================================================
 // 4.8.5.         .
 void ServiceSetProfileByIndex(int nProfile,  //     .      .    64.
                               int bWaitEnd); //     :
                                              //   TRUE  -         ( );
                                              //   FALSE -      ,     ( ).
 //========================================================================================================================================================================
 // 4.8.6.         .
 void ServiceSetProfileNext();
 //========================================================================================================================================================================
 // 4.8.7.         .
 void ServiceSetProfilePrevious();
 //
 // 5.      "".
 //
 // 5.1.   .    ,   567 .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.1.1.1.   ANSI-       .
 //                    .
 string ServiceServerByIndexA(int nIndex); //   ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.1.1.2.   UNICODE-       .
 //                    .
 string ServiceServerByIndexW(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.1.2.      .
 int ServiceServers();
 //========================================================================================================================================================================
 // 5.1.3.1.   TRUE,        ,  - FALSE.    ANSI-.
 BOOL ServiceIsServerA(uchar &szNameServer[]); //  .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.1.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
 BOOL ServiceIsServerW(string sNameServer); //  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.2.   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.2.1.         .    ,    TRUE,    - FALSE.
 BOOL ServiceAccountIsDemo(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.2.2.1.   ANSI-       .
 //                    .
 string ServiceAccountNameByIndexA(int nIndex); //   ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.2.2.   UNICODE-       .
 //                    .
 string ServiceAccountNameByIndexW(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.2.3.         .          .
 int ServiceAccountNumByIndex(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.2.4.1.   ANSI-       .           .
 //             567    .
 string ServiceAccountServerByIndexA(int nIndex); //   ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.4.2.   UNICODE-       .           .
 //             567    .
 string ServiceAccountServerByIndexW(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.2.5.      .
 int ServiceAccounts();
 //========================================================================================================================================================================
 // 5.2.6.1.   TRUE,               ,  - FALSE.
 //             ANSI-.
 BOOL ServiceIsAccountFullA(uchar &szNameServer[], //  .    567   .
                            uchar &szName[],       //   .
                            int    nNumber);       //  .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.6.2.   TRUE,               ,  - FALSE.
 //             UNICODE-.
 BOOL ServiceIsAccountFullW(string sNameServer, //  .    567   .
                            string sName,       //   .
                            int    nNumber);    //  .
 //========================================================================================================================================================================
 // 5.2.7.1.   TRUE,         ,  - FALSE.    ANSI-.
 BOOL ServiceIsAccountNameA(uchar &szName[]); //   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.7.2.   TRUE,         ,  - FALSE.    UNICODE-.
 BOOL ServiceIsAccountNameW(string sName); //   .
 //========================================================================================================================================================================
 // 5.2.8.   TRUE,        ,  - FALSE.
 BOOL ServiceIsAccountNumber(int nNumber); //  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.3.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.3.1.1.   ANSI-        .
 //                    .
 string ServiceStdIndicatorByIndexA(int nIndex); //    ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.1.2.   UNICODE-        .
 //                    .
 string ServiceStdIndicatorByIndexW(int nIndex); //    ,   .
 //========================================================================================================================================================================
 // 5.3.2.       .
 int ServiceStdIndicators();
 //========================================================================================================================================================================
 // 5.3.3.1.   TRUE,         ,  - FALSE.    ANSI-.
 BOOL ServiceIsStdIndicatorA(uchar &szNameIndicator[]); //   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.3.3.2.   TRUE,         ,  - FALSE.    UNICODE-.
 BOOL ServiceIsStdIndicatorW(string sNameIndicator); //   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.4.   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.4.1.1.   ANSI-       .
 //                    .
 string ServiceExpertByIndexA(int nIndex); //   ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.1.2.   UNICODE-       .
 //                    .
 string ServiceExpertByIndexW(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.4.2.      .
 int ServiceExperts();
 //========================================================================================================================================================================
 // 5.4.3.1.   TRUE,        ,  - FALSE.    ANSI-.
 BOOL ServiceIsExpertA(uchar &szNameExpert[]); //  .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.4.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
 BOOL ServiceIsExpertW(string sNameExpert); //  .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.5.    .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.5.1.1.   ANSI-        .
 //                    .
 string ServiceCustomIndicatorByIndexA(int nIndex); //    ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.1.2.   UNICODE-        .
 //                    .
 string ServiceCustomIndicatorByIndexW(int nIndex); //    ,   .
 //========================================================================================================================================================================
 // 5.5.2.       .
 int ServiceCustomIndicators();
 //========================================================================================================================================================================
 // 5.5.3.1.   TRUE,         ,  - FALSE.    ANSI-.
 BOOL ServiceIsCustomIndicatorA(uchar &szNameIndicator[]); //   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.5.3.2.   TRUE,         ,  - FALSE.    UNICODE-.
 BOOL ServiceIsCustomIndicatorW(string sNameIndicator); //   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.6.   .
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 5.6.1.1.   ANSI-       .
 //                    .
 string ServiceScriptByIndexA(int nIndex); //   ,   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.1.2.   UNICODE-       .
 //                    .
 string ServiceScriptByIndexW(int nIndex); //   ,   .
 //========================================================================================================================================================================
 // 5.6.2.      .
 int ServiceScripts();
 //========================================================================================================================================================================
 // 5.6.3.1.   TRUE,        ,  - FALSE.    ANSI-.
 BOOL ServiceIsScriptA(uchar &szNameScript[]); //  .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.6.3.2.   TRUE,        ,  - FALSE.    UNICODE-.
 BOOL ServiceIsScriptW(string sNameScript); //  .
 //
 // 6.      " ".
 //
 // 6.1.1.     MqlStrA-    " "    .      -1.
 int ServiceGetAllSymbolsMA(string &asSymbols[],   //     MqlStrA-    " ".
                                                   //         !
                                                   //       MQL4.
                            int     nSizeSymbols); //     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.1.2.     MqlStrW-    " "    .      -1.
 int ServiceGetAllSymbolsMW(string &asSymbols[],   //     MqlStrW-    " ".
                                                   //         !
                                                   //       MQL4.
                            int     nSizeSymbols); //     .
 //========================================================================================================================================================================
 // 6.2.       " ".      -1.
 int ServiceGetNumberTools();
 //========================================================================================================================================================================
 // 6.3.1.       " "    .    ,   -1.
 //           ANSI-.
 int ServiceLineBySymbolA(uchar &szSymbol[]); //     " ".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.3.2.       " "    .    ,   -1.
 //           UNICODE-.
 int ServiceLineBySymbolW(string sSymbol); //     " ".
 //========================================================================================================================================================================
 // 6.4.1.     ,    " "   ,     .
 //        ,   ,     ,  - NULL.
 //         .    ANSI-.
 int ServiceOpenChartA(uchar &szSymbol[]); //     " ".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.4.2.     ,    " "   ,     .
 //        ,   ,     ,  - NULL.
 //         .    UNICODE-.
 int ServiceOpenChartW(string sSymbol); //     " ".
 //========================================================================================================================================================================
 // 6.5.1.     ,    nLine  " ".
 //        ,   ,     ,  - NULL.
 //               ,    NULL    .
 //           ANSI-.
 int ServiceOpenChartByIndexA(int    nLine,         //     " ",   .
                              uchar &szBufSymbol[], //       ,     .
                              int    nSizeBuf);     //    .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.5.2.     ,    nLine  " ".
 //        ,   ,     ,  - NULL.
 //               ,    NULL    .
 //           UNICODE-.
 int ServiceOpenChartByIndexW(int    nLine,      //     " ",   .
                              string sBufSymbol, //       ,     .
                              int    nSizeBuf);  //    .
 //========================================================================================================================================================================
 // 6.6.1.     ,    " "   ,       .
 //        ,   ,     ,  - NULL.  .    ANSI-.
 int ServiceOpenChartSetIndexTfA(uchar &szSymbol[],  //     " ".
                                 int    nTimeFrame); //     0  8.
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.6.2.     ,    " "   ,       .
 //        ,   ,     ,  - NULL.  .    UNICODE-.
 int ServiceOpenChartSetIndexTfW(string sSymbol,     //     " ".
                                 int    nTimeFrame); //     0  8.
 //========================================================================================================================================================================
 // 6.7.1.     ,    " "   ,    .
 //        ,   ,     ,  - NULL.  .    ANSI-.
 int ServiceOpenChartSetPeriodA(uchar &szSymbol[], //     " ".
                                int    nPeriod);   //   .        .
                                                   //   PERIOD_M1       1   1 ;
                                                   //   PERIOD_M5       5   5 ;
                                                   //   PERIOD_M15     15  15 ;
                                                   //   PERIOD_M30     30  30 ;
                                                   //   PERIOD_H1      60   1 ;
                                                   //   PERIOD_H4     240   4 ;
                                                   //   PERIOD_D1    1440   1 ;
                                                   //   PERIOD_W1   10080   1 ;
                                                   //   PERIOD_MN1  43200   1 .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.7.2.     ,    " "   ,    .
 //        ,   ,     ,  - NULL.  .    UNICODE-.
 int ServiceOpenChartSetPeriodW(string sSymbol,  //     " ".
                                int    nPeriod); //   .        .
                                                 //   PERIOD_M1       1   1 ;
                                                 //   PERIOD_M5       5   5 ;
                                                 //   PERIOD_M15     15  15 ;
                                                 //   PERIOD_M30     30  30 ;
                                                 //   PERIOD_H1      60   1 ;
                                                 //   PERIOD_H4     240   4 ;
                                                 //   PERIOD_D1    1440   1 ;
                                                 //   PERIOD_W1   10080   1 ;
                                                 //   PERIOD_MN1  43200   1 .
 //========================================================================================================================================================================
 // 6.8.1.     ,    " "   ,      .
 //        ,   ,     ,  - NULL.  .    ANSI-.
 int ServiceOpenChartSetTfA(uchar &szSymbol[],     //     " ".
                            uchar &szTimeFrame[]); //   : ""         NULL     .
                                                   //                          "M1"    1 ;
                                                   //                          "M5"    5 ;
                                                   //                          "M15"  15 ;
                                                   //                          "M30"  30 ;
                                                   //                          "H1"    1 ;
                                                   //                          "H4"    4 ;
                                                   //                          "D1"    1 ;
                                                   //                          "W1"    1 ;
                                                   //                          "MN1"   1 .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.8.2.     ,    " "   ,      .
 //        ,   ,     ,  - NULL.  .    UNICODE-.
 int ServiceOpenChartSetTfW(string sSymbol,     //     " ".
                            string sTimeFrame); //   : ""         NULL     .
                                                //                          "M1"    1 ;
                                                //                          "M5"    5 ;
                                                //                          "M15"  15 ;
                                                //                          "M30"  30 ;
                                                //                          "H1"    1 ;
                                                //                          "H4"    4 ;
                                                //                          "D1"    1 ;
                                                //                          "W1"    1 ;
                                                //                          "MN1"   1 .
 //========================================================================================================================================================================
 // 6.9.1.          " ".    ANSI-.
 string ServiceSymbolByLineA(int nLine); //     " ",   .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.9.2.          " ".    UNICODE-.
 string ServiceSymbolByLineW(int nLine); //     " ",   .
 //
 // 7.      "".
 //
 // 7.1.     "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.1.1.          .
 //          TRUE,     ,  - FALSE.
 BOOL ServiceTerminalBoxCloseByHandle(int hwndMail); //    .
 //========================================================================================================================================================================
 // 7.1.2.1.         .    ANSI-.
 //            TRUE,     ,  - FALSE.
 BOOL ServiceTerminalBoxCloseByNameA(uchar &szTitleMail[]); //     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.1.2.2.         .    UNICODE-.
 //            TRUE,     ,  - FALSE.
 BOOL ServiceTerminalBoxCloseByNameW(string sTitleMail); //     .
 //========================================================================================================================================================================
 // 7.1.3.1.             .    ANSI-.
 string ServiceTerminalBoxReadTextA(int hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.1.3.2.             .    UNICODE-.
 string ServiceTerminalBoxReadTextW(int hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
 //========================================================================================================================================================================
 // 7.1.4.1.   HTML-          .    ANSI-.
 string ServiceTerminalBoxReadHTMLA(int hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.1.4.2.   HTML-          .    UNICODE-.
 string ServiceTerminalBoxReadHTMLW(int hwndMail); //    ,   ServiceMailboxOpen()  ServiceNewsOpen().
 //========================================================================================================================================================================
 // 7.1.5.      ""   .
 void ServiceTerminalSetTabByIndex(int nTabId); //    "".
 //========================================================================================================================================================================
 // 7.1.6.1.      ""   .    ANSI-.
 //           .   "" -   -  .    "ServiceTerminalSetTabByIndex()".
 void ServiceTerminalSetTabByNameA(uchar &szNameTab[]); //    "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.1.6.2.      ""   .    UNICODE-.
 //           .   "" -   -  .    "ServiceTerminalSetTabByIndex()".
 void ServiceTerminalSetTabByNameW(string sNameTab); //    "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.2.    " ".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.2.1.            " "  "".
 //             TRUE,  - FALSE.
 BOOL ServiceMailboxDelete(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.2.1.         " "  ""   .    ANSI-.
 string ServiceMailboxGetFromA(int nLine); //    " "  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.2.2.         " "  ""   .    UNICODE-.
 string ServiceMailboxGetFromW(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.3.1.        ,    ( ),   " "  ""
 //           ,     .   -1,    .    ANSI-.
 int ServiceMailboxGetLineA(uchar &szDataTime[], //    "YYYY.MM.DD HH:MM".           .
                            uchar &szFrom[],     //   .       .
                            uchar &szTheme[],    //  .       .
                            int    nStart,       //      ( ),     .    .
                            int    nCount);      //    .    -1,     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.3.2.        ,    ( ),   " "  ""
 //           ,     .   -1,    .    UNICODE-.
 int ServiceMailboxGetLineW(string sDataTime, //    "YYYY.MM.DD HH:MM".           .
                            string sFrom,     //   .       .
                            string sTheme,    //  .       .
                            int    nStart,    //      ( ),     .    .
                            int    nCount);   //    .    -1,     .
 //========================================================================================================================================================================
 // 7.2.4.1.        " "  ""        "YYYY.MM.DD HH:MM".
 //             ANSI-.
 string ServiceMailboxGetStringTimeA(int nLine); //    " "  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.4.2.        " "  ""        "YYYY.MM.DD HH:MM".
 //             UNICODE-.
 string ServiceMailboxGetStringTimeW(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.5.        " "  ""      UNIXTIME.
 datetime ServiceMailboxGetTime(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.6.1.        " "  ""   .    ANSI-.
 string ServiceMailboxGetThemeA(int nLine); //    " "  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.6.2.        " "  ""   .    UNICODE-.
 string ServiceMailboxGetThemeW(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.7.             " "  ""     
 //        .   ,        "ServiceSetTerminalTab()". ,    .
 int ServiceMailboxOpen(int nLine); //    " "  "".
 //========================================================================================================================================================================
 // 7.2.8.        " "  "".
 int ServiceMailboxRows();
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.3.    "".
 //xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
 // 7.3.1.        ""  "".
 int ServiceNewsColumns();
 //========================================================================================================================================================================
 // 7.3.2.1.       ""  ""   .    ANSI-.
 string ServiceNewsGetCategoryA(int nLine); //    ""  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.3.2.2.       ""  ""   .    UNICODE-.
 string ServiceNewsGetCategoryW(int nLine); //    ""  "".
 //========================================================================================================================================================================
 // 7.3.3.1.       ,    ( ),   ""  ""  ,
 //              .   -1,    .    ANSI-.
 int ServiceNewsGetLineA(uchar &szDataTime[], //    "YYYY.MM.DD HH:MM".           .
                         uchar &szTheme[],    //  .       .
                         int    nStart,       //      ( ),     .    .
                         int    nCount);      //    .    -1,     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.3.3.2.       ,    ( ),   ""  ""  ,
 //              .   -1,    .    UNICODE-.
 int ServiceNewsGetLineW(string sDataTime, //    "YYYY.MM.DD HH:MM".           .
                         string sTheme,    //  .       .
                         int    nStart,    //      ( ),     .    .
                         int    nCount);   //    .    -1,     .
 //========================================================================================================================================================================
 // 7.3.4.1.       ""  ""        "YYYY.MM.DD HH:MM".
 //             ANSI-.
 string ServiceNewsGetStringTimeA(int nLine); //    ""  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.3.4.2.       ""  ""        "YYYY.MM.DD HH:MM".
 //             UNICODE-.
 string ServiceNewsGetStringTimeW(int nLine); //    ""  "".
 //========================================================================================================================================================================
 // 7.3.5.1.       ""  ""   .    ANSI-.
 string ServiceNewsGetThemeA(int nLine); //    ""  "".
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.3.5.2.       ""  ""   .    UNICODE-.
 string ServiceNewsGetThemeW(int nLine); //    ""  "".
 //========================================================================================================================================================================
 // 7.3.6.       ""  ""      UNIXTIME.
 datetime ServiceNewsGetTime(int nLine); //    ""  "".
 //========================================================================================================================================================================
 // 7.3.7.            ""  ""       .
 //          ,        "ServiceSetTerminalTab()". ,    .
 int ServiceNewsOpen(int nLine); //    ""  "".
 //========================================================================================================================================================================
 // 7.3.8.        ""  "".
 int ServiceNewsRows();
 //
 // 8.     MQL4.
 //
 // 8.1.      .      TRUE,  - FALSE.
 BOOL ServiceDeleteExpert(int hwndChart); //    ,  .
 //========================================================================================================================================================================
 // 8.2.1.     MqlStrA-    .
 void ServiceDeleteIndicatorsByNameMA(int     hwndChart,           //   ,   .
                                      int     nWindow,             //     .  -1,      .
                                      string &asNamesIndicators[], //    MqlStrA-  .
                                      int     nSize);              //  .     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.2.2.     MqlStrW-    .
 void ServiceDeleteIndicatorsByNameMW(int     hwndChart,           //   ,   .
                                      int     nWindow,             //     .  -1,      .
                                      string &asNamesIndicators[], //    MqlStrW-  .
                                      int     nSize);              //  .     .
 //========================================================================================================================================================================
 // 8.3.      .      TRUE,  - FALSE.
 BOOL ServiceDeleteScript(int hwndChart); //    ,  .
 //========================================================================================================================================================================
 // 8.4.              ,   ,
 //       - NULL.
 int ServiceDialogScript(int bInstruction); //      : TRUE -  , FALSE -   .
 //========================================================================================================================================================================
 // 8.5.1.   MqlStrA-     .
 //                   "nWindow",  .
 int ServiceGetNamesIndicatorsMA(int     hwndChart,      //   ,   .
                                 int     nWindow,        //  .  -1,       .
                                 string &asIndicators[], //      MqlStrA- .
                                                         //         !
                                                         //       MQL4.
                                 int     nSize);         //   "amsIndicatorName[]"    .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.5.2.   MqlStrW-     .
 //                   "nWindow",  .
 int ServiceGetNamesIndicatorsMW(int     hwndChart,      //   ,   .
                                 int     nWindow,        //  .  -1,       .
                                 string &asIndicators[], //      MqlStrW- .
                                                         //         !
                                                         //       MQL4.
                                 int     nSize);         //   "amsIndicatorName[]"    .
 //========================================================================================================================================================================
 // 8.6.1.   TRUE,     ,  - FALSE.    ANSI-.
 BOOL ServiceIsPropertiesExpertA(uchar &szNameExpert[]); //  ,     .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.6.2.   TRUE,     ,  - FALSE.    UNICODE-.
 BOOL ServiceIsPropertiesExpertW(string sNameExpert); //  ,     .
 //========================================================================================================================================================================
 // 8.7.     .       2,5 .        ,
 //        FALSE.
 BOOL ServiceListIndicators(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 8.8.1.          .    ANSI-.
 void ServiceLoadCustomIndicatorA(int    hwndChart,         //    ,   .
                                  uchar &szNameIndicator[], //   .
                                  int    bOK);              //   ,      .
                                                            //   TRUE  -    "OK" .
                                                            //   FALSE -    "OK" .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.8.2.          .    UNICODE-.
 void ServiceLoadCustomIndicatorW(int    hwndChart,      //    ,   .
                                  string sNameIndicator, //   .
                                  int    bOK);           //   ,      .
                                                         //   TRUE  -    "OK" .
                                                         //   FALSE -    "OK" .
 //========================================================================================================================================================================
 // 8.9.1.         .    ANSI-.
 void ServiceLoadExpertA(int    hwndChart,      //    ,   .
                         uchar &szNameExpert[], //   .
                         int    bOK);           //   ,      .
                                                //   TRUE  -    "OK" .
                                                //   FALSE -    "OK" .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.9.2.         .    UNICODE-.
 void ServiceLoadExpertW(int    hwndChart,   //    ,   .
                         string sNameExpert, //   .
                         int    bOK);        //   ,      .
                                             //   TRUE  -    "OK" .
                                             //   FALSE -    "OK" .
 //========================================================================================================================================================================
 // 8.10.1.         .    ANSI-.
 void ServiceLoadScriptA(int    hwndChart,      //    ,   .
                         uchar &szNameScript[], //   .
                         int    bOK);           //   ,      .
                                                //   TRUE  -    "OK" .
                                                //   FALSE -    "OK" .
                                                //        !
                                                //              
                                                // -        .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.10.2.         .    UNICODE-.
 void ServiceLoadScriptW(int    hwndChart,   //    ,   .
                         string sNameScript, //   .
                         int    bOK);        //   ,      .
                                             //   TRUE  -    "OK" .
                                             //   FALSE -    "OK" .
                                             //        !
                                             //              
                                             // -        .
 //========================================================================================================================================================================
 // 8.11.1.          .    ANSI-.
 void ServiceLoadStdIndicatorA(int    hwndChart,         //    ,   .
                               uchar &szNameIndicator[], //   .
                               int    bOK);              //   ,      .
                                                         //   TRUE  -    "OK" .
                                                         //   FALSE -    "OK" .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.11.2.          .    UNICODE-.
 void ServiceLoadStdIndicatorW(int    hwndChart,      //    ,   .
                               string sNameIndicator, //   .
                               int    bOK);           //   ,      .
                                                      //   TRUE  -    "OK" .
                                                      //   FALSE -    "OK" .
 //========================================================================================================================================================================
 // 8.12.     .      TRUE,  - FALSE.
 BOOL ServicePropertiesExpert(int hwndChart); //    ,      .
 //========================================================================================================================================================================
 // 8.13.  / ,   "".
 void ServiceSetExperts();
 //
 // 9.        .
 //
 // 9.1.1.   ,    .    ANSI-.
 void ServiceLoginApplyA(int    nLogin,         //  .      (nLogin = 0),     --.
                         uchar &szPassword[],   // .       ,     .
                         uchar &szNameServer[], //  .        ,     .
                         int    bStoreInfo);    //    - TRUE.     - FALSE.
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 9.1.2.   ,    .    UNICODE-.
 void ServiceLoginApplyW(int    nLogin,      //  .      (nLogin = 0),     --.
                         string sPassword,   // .       ,     .
                         string sNameServer, //  .        ,     .
                         int    bStoreInfo); //    - TRUE.     - FALSE.
 //========================================================================================================================================================================
 // 9.2.        .
 //                  ,  - NULL.
 int ServiceLoginBoxHandle();
 //========================================================================================================================================================================
 // 9.3.1.     (     )  .    ANSI-.
 string ServiceLoginNameServerA();
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 9.3.2.     (     )  .    UNICODE-.
 string ServiceLoginNameServerW();
 //
 //10.  .
 //
 //10.1.    .      2,5 ,     .
 //             ,  .
 void ServiceAlertClose();
 //========================================================================================================================================================================
 //10.2.   TRUE,    ,  - FALSE.
 BOOL ServiceAlertIs();
 //========================================================================================================================================================================
 //10.3.   ,     ,   ,     ,  ,
 //         .
 //          ,     ,      ,    .
 void ServiceGetCursorInfo(int &aiCursorInfo[], //    .
                                                // aiCursorInfo[0] -   ,   .
                                                // aiCursorInfo[1] -   X .
                                                // aiCursorInfo[2] -   Y .
                                                // aiCursorInfo[3] -   X .
                                                // aiCursorInfo[4] -   Y .
                                                // aiCursorInfo[5] -  ,    .
                                                //                      -1  0xFFFFFFFF,       .
                           int  nSize);         //  .
 //========================================================================================================================================================================
 //10.4.1.      "HOME"           " ".
 //             0,    1.      -1   .
 //         sScriptSensor      .      nLoading, bMode, abScanTF  
 //        .  bMode, abScanTF      nLoading = MLQ_CONTINUED.    ANSI-.
 int ServiceLoaderQuotesA(int    nLoading,          //   :
                                                    //   MLQ_STOP_TF              
                                                    //                        "bMode";
                                                    //   MLQ_CONTINUED       ;
                                                    //   MLQ_FINISH       .
                          int    bHowScanTools,     //   :
                                                    //   TRUE  -        ;
                                                    //   FALSE -        .
                          int   &abScanTF[9],       //     .       9 .
                          uchar &szScriptSensor[]); //  -             .
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //10.4.2.      "HOME"           " ".
 //             0,    1.      -1   .
 //         sScriptSensor      .      nLoading, bMode, abScanTF  
 //        .  bMode, abScanTF      nLoading = MLQ_CONTINUED.    UNICODE-.
 int ServiceLoaderQuotesW(int    nLoading,       //   :
                                                 //   MLQ_STOP_TF              
                                                 //                        "bMode";
                                                 //   MLQ_CONTINUED       ;
                                                 //   MLQ_FINISH       .
                          int    bHowScanTools,  //   :
                                                 //   TRUE  -        ;
                                                 //   FALSE -        .
                          int   &abScanTF[9],    //     .       9 .
                          string sScriptSensor); //  -             .
 //========================================================================================================================================================================
 //10.5.          .
 int ServiceOpenDeletetChart(int nChart); //      .
 //========================================================================================================================================================================
 //10.6.1.     . ,   ,     ,  - NULL.
 //           ANSI-.
 int ServiceOpenOfflineChartA(uchar &szSymbol[],  //  .
                              uchar &szPeriod[]); // . : M1, M2, M5, H1, H12, Daily, Weekly, Monthly, D90, D360, D1440.
 //------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //10.6.2.     . ,   ,     ,  - NULL.
 //           UNICODE-.
 int ServiceOpenOfflineChartW(string sSymbol,  //  .
                              string sPeriod); // . : M1, M2, M5, H1, H12, Daily, Weekly, Monthly, D90, D360, D1440.
 //========================================================================================================================================================================
 //10.7.   .      TRUE,  - FALSE.
 BOOL ServiceRescanServers();
 //========================================================================================================================================================================
 //10.8.        "ServiceLoaderQuotes()".
 //              ,      .
 void ServiceSensorLoadQuotes(int hwndChart); //    ,     .
 //========================================================================================================================================================================
#import
//
/*
07.11.2010.  0.11.7.1.
1.  ServiceNoAutoScroll()   ServiceAutoScroll().
2.  ServiceSetActiveChart()   ServiceActiveChart(). 
3.   .
4.         H1.
5.          VOID.
6.   ServiceOpenChart()     .
7.   ServiceDeleteIndicatorsByName(), ServiceHotKeysChart(), ServiceIsChart(), ServiceKeyChart(), ServiceKeyTerminal(), ServiceLogin(),
   ServiceNumberTools(), ServiceOpenChartByNumber(), ServiceOpenChartByName(), ServiceOpenOfflineChart().

08.11.2010.  0.11.8.3.
1.   ServiceGetAllSymbols().    .   .     .
2.   .

01.12.2010.  0.12.1.1.
1.    .    .
2.  "".              (         !!!).
      .   !
3.    ServiceActiveChart()  ServiceSetActiveChart().
4.    ServiceNumberTools()  ServiceGetNumberTools(). 
5.   ServiceGetNameServer(), ServiceOpenDeletetChart(), ServiceSetTemplateByName(), ServiceSetTemplateByNumber().

05.12.2010.  0.12.5.1. 
1.   ServiceTerminalClose(), ServiceTerminalHide(), ServiceTerminalMaximize(), ServiceTerminalMinimize(), ServiceTerminalRestore(), ServiceTerminalShow(), ServiceLoadingQuotes().
2.       ServiceOpenChartByNumber().

06.12.2010.  0.12.6.1.
1.      .     .     .

09.02.2011.  1.2.9.1.
1.   ServiceDeinit(), ServiceInit(), ServiceGetLocalization(), ServiceSensorLoadQuotes(). 
2.           : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
3.        Windows XP.
4.       .

05.04.2011.  1.4.5.1.
1.  : ServiceOpenGlobalVariables(), ServiceOpenHistoryCenter(), ServiceOpenOptions(),
                      ServiceShift(), ServiceShowGrid(), ServiceShowVolume(), ServiceGetAutoScroll(), ServiceGetScaleFix(), ServiceGetScaleFix1To1(),
                      ServiceGetForeground(), ServiceGetOffline(), ServiceGetShift(), ServiceGetShowAsk(), ServiceGetShowGrid(), ServiceGetShowObjectDescript(), ServiceGetShowOHLC(), ServiceGetShowPeriodSeparators(), ServiceGetShowVolume(), ServiceGetViewChart(),
                      ServiceSetAutoScroll(), ServiceSetOffline(), ServiceSetScale(), ServiceSetScaleFix(), ServiceSetScaleFix1To1(), ServiceSetForeground(), ServiceSetShift(), ServiceSetShowAsk(), ServiceSetShowGrid(), ServiceSetShowObjectDescript(),
                      ServiceSetShowOHLC(), ServiceSetShowPeriodSeparators(), ServiceSetShowVolume(), ServiceSetViewChart(),
                      ServiceOpenPropertiesChart(), ServicePropertiesChartCheckBox(), ServiceStepByStep(), ServiceGetNamesIndicators().
2.  : ServiceOpenChartByName(), ServiceListIndicators(), ServiceDeleteIndicatorsByName(), ServiceAutoScroll().
3.       4 (392).
4.      ServiceLogin().

03.05.2011.  1.5.3.1.
1.  : ServiceGetPathTerminal(), ServiceGetAllHandlesCharts(), ServiceSetToolChartNamePeriod(), ServiceSetToolChartNumberPeriod(), ServiceSetToolChartPeriod(). 
2.     ServiceOpenChartByNumber().

05.10.2011.  1.10.5.1.
1.  : ServiceHideDataWindow(), ServiceHideMarketWatch(), ServiceHideNavigator(), ServiceHideTerminal(), ServiceHideTester(),
                      ServiceShowDataWindow(), ServiceShowMarketWatch(), ServiceShowNavigator(), ServiceShowTerminal(), ServiceShowTester(), ServiceIsChartActive(), ServiceChartKeyUp(), ServiceSetTerminalTabByNumber(), ServiceSetTerminalTabByName(), ServiceMailboxCloseByHandle(),
                      ServiceMailboxCloseByName(), ServiceMailboxDelete(), ServiceMailboxGetFrom(), ServiceMailboxGetLine(), ServiceMailboxGetStringTime(), ServiceMailboxGetTime(), ServiceMailboxGetTheme(), ServiceMailboxOpen(), ServiceMailboxReadText(), ServiceMailboxReadHTML(),
                      ServiceCloseCmd(), ServiceIsVisibleCmd(), ServiceOpenCmd(), ServiceReadCmd(), ServiceWriteCmd(),
                      ServiceRefreshAllCharts(), ServiceRefreshAllOnceCharts(), ServiceRefreshChart(), ServiceStopRefreshChart(), ServiceStopRefreshAllCharts(),
                      ServiceHandleMT4(), ServiceSetAccountNumber(), ServiceGetCursorPos().
2.  : ServiceGetPathTerminal(), ServiceTerminalClose(), ServiceTerminalHide(), ServiceTerminalMaximize(), ServiceTerminalMinimize(), ServiceTerminalRestore(), ServiceTerminalShow(), ServiceHotKeysTerminal(), ServiceKeyTerminal(), ServiceHotKeysChart(), ServiceKeyChart().
    : ServiceGetPathMT4(), ServiceMetaTraderClose(), ServiceMetaTraderHide(), ServiceMetaTraderMaximize(), ServiceMetaTraderMinimize(), ServiceMetaTraderRestore(), ServiceMetaTraderShow(), ServiceMetaTraderHotKeys(), ServiceMetaTraderKeyDown(), ServiceChartHotKeys(), ServiceChartKeyDown().
3.      VOID  BOOL : ServiceMetaTraderClose(), ServiceMetaTraderHide(), ServiceMetaTraderMaximize(), ServiceMetaTraderMinimize(), ServiceMetaTraderRestore(), ServiceMetaTraderShow().
4.      ServiceSymbolByLine()  .
5.    : ServicePropertiesChartCheckBox(), ServiceSetTemplateByName().

22.11.2011.  1.11.22.1.
1.     ServiceDeleteIndicatorsByName()      .
2.       MQL4 : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
3.              409.

11.03.2012.  2.3.11.2.
1.     4 416      .
2.     10 .
3.         .
4.  : ServiceGetProcessId(); ServiceMetaTraderTitle(), ServiceNumberCharts().

04.04.2012.  2.4.4.1.
1.        (  4.7.).         .

17.07.2012.  2.7.17.1.
1.  : ServiceGetPathServer().
2.   ServiceGetPathMT4()  ServiceGetPathDirectoryMT4().

22.09.2012.  2.9.22.3.
1.     4 438      .
2.      4.

05.10.2012.  2.10.22.1.
1.    4.2 : ServiceGetHandleActiveChart(), ServiceGetHandleChart(), ServiceGetHandlesEqualCharts().
2.    ServiceOpenChartByName()  ServiceOpenChartSetTf().
3.    5 : ServiceOpenChart(), ServiceOpenChartSetNumberTf(), ServiceOpenChartSetPeriod().
4.         : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().
5.      BOOL  VOID  : ServiceLoadCustomIndicator(), ServiceLoadExpert(), ServiceLoadScript(), ServiceLoadStdIndicator().

30.10.2012.  2.10.30.1.
1.   ServiceOpenChartByNumber().        ,    NULL    .
2.    4.4  ServiceSaveTemplate().

11.11.2012.  2.11.11.1.
1.   .
2.      ServiceSaveTemplate().
3.     4 445.
4.      .
5.   ServiceGetPathDirectoryMT4(), ServiceGetPathServer()   ServicePathDirectoryMT4(), ServicePathServer().
6.    2.1 : ServiceBuild(), ServiceVersion(), ServiceVersionDate().
7.      4.7: ServiceRefreshAllCharts(), ServiceRefreshAllOnceCharts(), ServiceRefreshChart().

13.11.2012.  2.11.13.1.
1.  ServiceVersion()    : "4.0.0.445".
2.   2.1   ServiceVersionFull(),    : "Version: 4.00  Build 445 (09 Nov 2012)".
3.      .  " "      .

16.11.2012.  2.11.16.1.
1.    Windows XP.

19.12.2012.  2.12.19.2.
1.   2   ServiceIsPropertiesExpert(),       .

11.02.2013.  3.2.11.6.
1.          ServiceGetHandleChart(), ServiceGetHandlesEqualCharts().
2.   . ,          ,     .

19.04.2013.  3.4.19.2.
1.   ServiceIsChartOffline()   4.2 "     ".
2.     ServiceGetAllHandlesCharts().      .      .
3.    ServiceGetAllHandlesCharts()  ServiceGetHandlesAllCharts().
4.    4.2  ServiceGetHandlesOfflineCharts()  ServiceGetHandlesOnlineCharts().
5.    4.7  ServiceRefreshOfflineCharts()  ServiceRefreshOnlineCharts().
6.       4.7.

05.05.2013.  3.5.5.1.
1.   6.1    4 494 (   "Code Base").

01.06.2013.  3.6.1.1.
1.   6.1    4 494 (   "Company").
2.     ServiceLogin().

14.06.2013.  3.6.14.1.
1.   8   ServiceAlertClose()  ServiceAlertIs().
2.    ServiceLoadScript()  4 505.

07.07.2013.  3.7.7.1.
1.   4.1   ServiceChartCheckPressKey().

22.07.2013.  3.7.22.1.
1.       ServiceMetaTraderHotKeys()  ServiceChartHotKeys().
2.    ServiceInit()  ServiceInitProcessId().
3.   1.1   ServiceInitPath().

04.02.2014.  4.2.4.1.
 1.          "A" (ANSI)       "W" (UNICODE).
 2.     4.6  ServiceCloseCmd(), ServiceClearCmd(), ServiceCreatCmd(), ServiceIsCmd(), ServiceIsVisibleCmd(), ServiceOpenCmd(), ServiceReadCmd(), ServiceWriteCmd()
      ServiceCmdClose(), ServiceCmdClear(), ServiceCmdCreat(), ServiceCmdHas(), ServiceCmdIsVisible(), ServiceCmdOpen(), ServiceCmdRead(), ServiceCmdWrite().
 3.     ServiceOpenChartByNumber(), ServiceSetTemplateByNumber(), ServiceSetTimeframeByNumber(), ServiceOpenChartSetNumberTf(), ServiceSetToolChartNumberPeriod()
      ServiceOpenChartByIndex(), ServiceSetTemplateByIndex(), ServiceSetTimeframeByIndex(), ServiceOpenChartSetIndexTf(), ServiceSetToolChartIndexPeriod().
 4.     ServiceCmdWrite().
 5.        ,  ServiceGetAllSymbols(), ServiceDeleteIndicatorsByName(), ServiceGetNamesIndicators()
        "M"    ServiceGetAllSymbolsMA(), ServiceGetAllSymbolsMW(), ServiceDeleteIndicatorsByNameMA(), ServiceDeleteIndicatorsByNameMW(), ServiceGetNamesIndicatorsMA(), ServiceGetNamesIndicatorsMW().
     : ServiceGetAllSymbolsA(), ServiceGetAllSymbolsW(), ServiceDeleteIndicatorsByNameA(), ServiceDeleteIndicatorsByNameW(), ServiceGetNamesIndicatorsA(), ServiceGetNamesIndicatorsW().
 6.       .
 7.   5      ""  : ServiceServerByIndexA(), ServiceServerByIndexW(), ServiceServers(), ServiceIsServerA(), ServiceIsServerW(),
    ServiceAccountIsDemo(), ServiceAccountNameByIndexA(), ServiceAccountNameByIndexW(), ServiceAccountNumByIndex(), ServiceAccountServerByIndexA(), ServiceAccountServerByIndexW(), ServiceAccounts(),
    ServiceIsAccountFullA(), ServiceIsAccountFullW(), ServiceIsAccountNameA(), ServiceIsAccountNameW(), ServiceIsAccountNumber(), ServiceStdIndicatorByIndexA(), ServiceStdIndicatorByIndexW(), ServiceStdIndicators(),
    ServiceIsStdIndicatorA(), ServiceIsStdIndicatorW(), ServiceExpertByIndexA(), ServiceExpertByIndexW(), ServiceExperts(), ServiceIsExpertA(), ServiceIsExpertW(), ServiceCustomIndicatorByIndexA(), ServiceCustomIndicatorByIndexW(),
    ServiceCustomIndicators(), ServiceIsCustomIndicatorA(), ServiceIsCustomIndicatorW(), ServiceScriptByIndexA(), ServiceScriptByIndexW(), ServiceScripts(), ServiceIsScriptA(), ServiceIsScriptW().
 8.  ServiceSetTerminalTabByNumber(), ServiceSetTerminalTabByNameA()  ServiceSetTerminalTabByNameW()     "",   529 .
 9.   4.4   ServiceSetTemplateByNameA(), ServiceSetTemplateByNameW(), ServiceSetTemplateByIndex()   ,      (/).
10.   4.4   ServiceDeleteTemplate().
11.  ServiceSetTemplateByIndex()    VOID.
12.   2.2     ServiceSetAccountNumber().
13.   2.2   ServiceMetaTraderReboot().
14.  2.4   ",     4".
15.   2.4   ServiceGetLocalization().
16.   2.4   ServiceOpenLogin().
17.          .      : , .       .
18.   2.5     : ServiceGetLocalId(), ServiceGetLocalStrA(), ServiceGetLocalStrW(), ServiceSetLocal().
19.   4.8    : ServiceDeleteProfile(), ServiceGetCurrentProfileA(), ServiceGetCurrentProfileW(), ServiceOpenSaveProfile(), ServiceSaveProfileA(),
    ServiceSaveProfileW(), ServiceSetProfileByIndex(), ServiceSetProfileNext(), ServiceSetProfilePrevious().
20.    ServiceSetTerminalTabByNumber()  ServiceSetTerminalTabByIndex().
21.               9.
22.   9  ServiceGetNameServer()  ServiceLogin()    ServiceLoginNameServer()  ServiceLoginApply().
23.   ServiceLoginApply()       .
24.   9   ServiceLoginBoxHandle().
25.  ServiceBuild()   ServiceVersionBuild().
26.   2.1   ServiceCurrentAccountNameA(), ServiceCurrentAccountNameW(), ServiceCurrentServerA(), ServiceCurrentServerW(), ServiceCurrentAccountNum(), ServiceNameMTA(),
    ServiceNameMTW(), ServicePathMTA(), ServicePathMTW(), ServicePathDataMTA(), ServicePathDataMTW(), ServiceStatusConnectId(), ServiceStatusConnectTextA(), ServiceStatusConnectTextW().
27.    ServiceInitProcessId().
28.     ServiceLoginApply().

22.03.2014.  4.3.22.0.
 1.     625.

10.05.2014.  4.5.10.0.
 1.     633.
 2.      7.1  ServiceSetTerminalTabByIndex(), ServiceSetTerminalTabByNameA(), ServiceSetTerminalTabByNameW()
      ServiceTerminalSetTabByIndex(), ServiceTerminalSetTabByNameA(), ServiceTerminalSetTabByNameW().
 3.      7.2  ServiceMailboxCloseByHandle(), ServiceMailboxCloseByNameA(), ServiceMailboxCloseByNameW(), ServiceMailboxReadTextA(), ServiceMailboxReadTextW(), ServiceMailboxReadHTMLA(), ServiceMailboxReadHTMLW()
      ServiceTerminalBoxCloseByHandle(), ServiceTerminalBoxCloseByNameA(), ServiceTerminalBoxCloseByNameW(), ServiceTerminalBoxReadTextA(), ServiceTerminalBoxReadTextW(), ServiceTerminalBoxReadHTMLA(), ServiceTerminalBoxReadHTMLW().
 4.    ServiceTerminalBoxCloseByHandle(), ServiceTerminalBoxCloseByNameA(), ServiceTerminalBoxCloseByNameW(), ServiceTerminalBoxReadTextA(), ServiceTerminalBoxReadTextW(), ServiceTerminalBoxReadHTMLA(), ServiceTerminalBoxReadHTMLW()
       7.2   7.1.
    
13.05.2014.  4.5.13.0.
 1.    7.3 "   """: ServiceNewsColumns(), ServiceNewsGetCategoryA(), ServiceNewsGetCategoryW(), ServiceNewsGetLineA(), ServiceNewsGetLineW(),
    ServiceNewsGetStringTimeA(), ServiceNewsGetStringTimeW(), ServiceNewsGetTime(), ServiceNewsGetThemeA(), ServiceNewsGetThemeW(), ServiceNewsOpen(), ServiceNewsRows().
 2.       : ServiceTerminalBoxReadTextA(), ServiceTerminalBoxReadTextW(), ServiceTerminalBoxReadHTMLA(), ServiceTerminalBoxReadHTMLW().
 3.   : ServiceTerminalBoxCloseByNameA(), ServiceTerminalBoxCloseByNameW().          . ,    .
 4.    ServiceMailboxSize()  ServiceMailboxRows().
    
24.05.2014.  4.5.24.0.
 1.         ,     ,     .
*/